// Datei: i2ctest.c
// Steuert das Hartmann Minidisplay ML12 mit PCF8576
// Zhlt auf dem Display rum, zeigt alle Sonderzeichen
//
// Die Tastaturmatrix wird nicht bearbeitet.
// Wer Routinen dazu braucht kann sich ja mal meinen
// 16 Kanal RC5-Sender ansehen. Der benutzt eine Matrixtastatur.
//
// hk@holger-klabunde.de 
// www.holger-klabunde.de 
// 24.03.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"
#include "i2c.h"
#include "minihart.h"

#include "i2c.c"
#include "delay.c"
#include "lcd.c"
#include "binbcd16.c"
#include "minihart.c"


//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,dp;
 unsigned long count;
 
 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben

 TRISA=0b10000;     //0=Ausgang, 1=Eingang
 PORTA=0b01000;  //Port einmal schreiben

 LCDInit();
 MHInit();
 
 LCDCls();
 LCDWrite("PCF8576 Test");

 count=0;
 dp=0; //Zhlt die Position des wandernden Dezimalpunktes
 
 while(1)
  {
   LCDPos(2,1);
   B1=(unsigned char)(count>>8);     //Highbyte
   B0=(unsigned char)(count&0x00FF); //Lowbyte
   BinToBCD16(); //Wandeln in BCD-Code, Ergebnis in R0..2, R0=MSB

   by=R1>>4; //Stelle 1
   by=MHConvertDigit(by); //wandeln in den Code frs Display
// Diese Stelle hat keinen Dezimalpunkt
//   if(dp==0) by+=SG_DP;   //Dezimalpunkt setzen
   MHWrite(1,by);    //Stelle schreiben
   
   by=R1&0x0F; //Stelle 2
   by=MHConvertDigit(by); //wandeln in den Code frs Display
   if(dp==1) by+=SG_DP;   //Dezimalpunkt setzen
   MHWrite(2,by);    //Stelle schreiben

   by=R2>>4; //Stelle 3
   by=MHConvertDigit(by); //wandeln in den Code frs Display
   if(dp==2) by+=SG_DP;   //Dezimalpunkt setzen
   MHWrite(3,by);    //Stelle schreiben

   by=R2&0x0F; //Stelle 4
   by=MHConvertDigit(by); //wandeln in den Code frs Display
   if(dp==3) by+=SG_DP;   //Dezimalpunkt setzen
   MHWrite(4,by);    //Stelle schreiben

   by=0xAE;
   MHWrite(5,by);    //alle Sonderzeichen an

   count++;
   dp++;
   if(dp==4) dp=0;
   if(count>9999) count=0; //Anzeige ist nur vierstellig

   Delay1ms(150);
   
  }//while 1
     
}

