// Datei: minihart.c
//
// I2C-Bus LCD Treiber PCF8576
// 7-Segment Anzeige mit 4 Stellen ansteuern
//
// hk@holger-klabunde.de 
// www.holger-klabunde.de 
// 19.01.2001
// Compiler CC5x
#include "prozess.h"      /* Der verwendete Prozessor */
#include "minihart.h"
#include "protos.h"

//bersetzungstabelle fr die bentigten LCD-Segmente zu der darzustellenden Zahl
const unsigned char mhdigit[] = { D_0 ,D_1 ,D_2 ,D_3 ,D_4 ,D_5 ,D_6 ,D_7 ,D_8 ,D_9 };


void MHInit()
{
 I2C_START(); //Startbedingung senden,enthlt I2C_STOP()!!

 I2C_Write(MINIHART); //I2C-Adresse und SchreibBit senden
// if(I2CERR>0) { return; }

 I2C_Write(0x4B); //1/3 Bias Normal Mode
// if(I2CERR>0) { return; }

 I2C_STOP();

}

//###############################################################
//Zahl umwandeln in den entsprechenden Code fr das Display
//###############################################################
unsigned char MHConvertDigit(unsigned char num)
{
 if(num>9) return 0; //Arraygrenzen unbedingt einhalten

 return mhdigit[num];
}

//###################################################
//Schreibt ein Byte in den PCF8576
//adr 1-4 ist die gewnschte Stelle
//adr=5 schreibt das Byte fr die Sonderzeichen
//###################################################
void MHWrite(unsigned char adr, unsigned char dat)
{
 unsigned char offs;
 
 I2C_START(); //Startbedingung senden,enthlt I2C_STOP()!!

 I2C_Write(MINIHART); //I2C-Adresse und SchreibBit senden
// if(I2CERR>0) { return; }

 switch(adr)
  {
   case 1: offs=0; break; //Stelle 1
   case 2: offs=3; break;
   case 3: offs=6; break;
   case 4: offs=9; break;
   case 5: offs=12; break; //Die Sonderzeichen
  }

 I2C_Write(offs); //Gewnschte Adresse bertragen
// if(I2CERR>0) { return; }

 I2C_Write(dat); //Byte schreiben
// if(I2CERR>0) { return; }

 I2C_STOP();

}
